package com.jsowell.netty.handler;

import com.alibaba.fastjson2.JSONObject;
import com.jsowell.common.core.domain.ykc.YKCDataProtocol;
import com.jsowell.common.core.domain.ykc.YKCFrameTypeCode;
import com.jsowell.common.util.BytesUtil;
import com.jsowell.common.util.YKCUtils;
import com.jsowell.netty.factory.YKCOperateFactory;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * 充电过程 BMS 信息  0x25
 *
 * GBT-27930 充电桩与 BMS 充电过程 BMS 信息
 * @author JS-ZZA
 * @date 2022/9/19 13:53
 */
@Slf4j
@Component
public class BMSInformationHandler extends AbstractHandler{
    private final String type = YKCUtils.frameType2Str(YKCFrameTypeCode.CHARGING_PROCESS_BMS_INFORMATION_CODE.getBytes());

    @Override
    public void afterPropertiesSet() throws Exception {
        YKCOperateFactory.register(type, this);
    }

    @Override
    public byte[] supplyProcess(YKCDataProtocol ykcDataProtocol, Channel channel) {
        log.info("[===充电过程 BMS 信息===] param:{}, channel:{}", JSONObject.toJSONString(ykcDataProtocol), channel.toString());
        // 获取消息体
        byte[] msgBody = ykcDataProtocol.getMsgBody();

        int startIndex = 0;
        int length = 16;

        // 交易流水号
        byte[] serialNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        // 桩编码
        startIndex += length;
        length = 7;
        byte[] pileSnByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);
        String pileSn = BytesUtil.bcd2Str(pileSnByteArr);

        // 保存时间
        saveLastTime(pileSn);

        // 枪号
        startIndex += length;
        length = 1;
        byte[] pileConnectorNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        // BMS 最高单体动力蓄电池电压所在编号   1/位， 1 偏移量； 数据范围： 1~256
        startIndex += length;
        byte[] BMSMaxVoltageNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        // BMS 最高动力蓄电池温度   1ºC/位， -50 ºC 偏移量；数据范 围： -50 ºC ~+200 ºC
        startIndex += length;
        byte[] BMSMaxBatteryTemperatureByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        // 最高温度检测点编号   1/位， 1 偏移量； 数据范围： 1~128
        startIndex += length;
        byte[] maxTemperatureDetectionNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        // 最低动力蓄电池温度   1ºC/位， -50 ºC 偏移量；数据范 围： -50 ºC ~+200 ºC
        startIndex += length;
        byte[] minBatteryTemperature = BytesUtil.copyBytes(msgBody, startIndex, length);

        // 最低动力蓄电池温度检测点编号   1/位， 1 偏移量； 数据范围： 1~128
        startIndex += length;
        byte[] minTemperatureDetectionNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        /**
         * 9-12
         * 9:  BMS 单体动力蓄电池电压过高 /过低   (<00> ：=正常 ; <01> ：=过高 ; <10>： =过低)
         * 10: BMS 整车动力蓄电池荷电状态 SOC 过高/过低  (<00> ：=正常 ; <01> ：=过高 ; <10>： =过低)
         * 11: BMS 动力蓄电池充电过电流  (<00> ：=正常 ; <01> ：=过流 ; <10>： =不可信状态)
         * 12: BMS 动力蓄电池温度过高  (<00> ：=正常 ; <01> ：=过流 ; <10>： =不可信状态)
         */
        startIndex += length;
        byte[] numNineToTwelve = BytesUtil.copyBytes(msgBody, startIndex, length);

        /**
         * 13-16
         * 13:  BMS 动力蓄电池绝缘状态  (<00> ：=正常 ; <01> ：=过流 ; <10>： =不可信状态)
         * 14:  BMS 动力蓄电池组输出连接器连接状态  (<00> ：=正常 ; <01> ：=过流 ; <10>： =不可信状态)
         * 15:  充电禁止  (<00>： =禁止; <01>： =允许)
         * 16:  预留位  00
         */
        startIndex += length;
        byte[] numThirteenToSixteen = BytesUtil.copyBytes(msgBody, startIndex, length);


        return null;
    }
}
